Name:		voms
Version:	1.9.2
Release:	2%{?dist}
Summary:	Virtual Organization Membership Service

Group:		System Environment/Libraries
License:	EU Datagrid
URL:		http://glite.web.cern.ch/glite/
Source:		%{name}-%{version}.tar.gz
Patch0:		%{name}-distribution-globus.patch
Patch1:		%{name}-cpparg.patch
#		https://savannah.cern.ch/bugs/index.php?46690
Patch2:		%{name}-missing-include.patch
#		https://savannah.cern.ch/bugs/index.php?46691
Patch3:		%{name}-missing-return.patch
#		https://savannah.cern.ch/bugs/index.php?46689
Patch4:		%{name}-clear-error.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:	globus-gssapi-gsi-devel
BuildRequires:	globus-gss-assist-devel
BuildRequires:	openssl-devel
BuildRequires:	krb5-devel
%if %{?suse_version:0}%{!?suse_version:1}
BuildRequires:	expat-devel
%else
BuildRequires:	expat
%endif
BuildRequires:  pkgconfig
BuildRequires:	libxslt
%if %{?suse_version:0}%{!?suse_version:1}
BuildRequires:	docbook-style-xsl
%else
BuildRequires:	docbook-xsl-stylesheets
%endif
BuildRequires:	doxygen
%if %{?fedora}%{!?fedora:0} >= 9
BuildRequires:	tex(latex)
%else
%if %{?rhel}%{!?rhel:0} >= 6
BuildRequires:	tex(latex)
%else
%if 0%{?suse_version} > 1020
BuildRequires:	texlive-latex
%else
%if 0%{?suse_version} > 0
BuildRequires:	te_latex
%else
BuildRequires:	tetex-latex
%endif
%endif
%endif
%endif

%description
VOMS - Virtual Organization Membership Service

%package devel
Summary:	Virtual Organization Membership Service Development Files
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	globus-gssapi-gsi-devel

%description devel
VOMS - Virtual Organization Membership Service Development Files

%package doc
Summary:	Virtual Organization Membership Service Documentation Files
Group:		Documentation

%description doc
VOMS - Virtual Organization Membership Service Documentation Files

%package clients
Summary:	Virtual Organization Membership Service Clients
Group:		Applications/Internet
Requires:	%{name} = %{version}-%{release}

%description clients
VOMS - Virtual Organization Membership Service Clients

%package server
Summary:	Virtual Organization Membership Service Server
Group:		Applications/Internet
Requires:	%{name} = %{version}-%{release}

%description server
VOMS - Virtual Organization Membership Service Server

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1

# Fix directory hardwiring
for f in `find . -name Makefile.am -o -name Makefile.in`; do
    sed -e 's!\(^libexecdir *= *\)\$(prefix)/libexec!\1@libexecdir@!' \
	-e 's!\(^includedir *= *\)\$(prefix)/include!\1@includedir@!' \
	-e 's!\(^defaultsysconfdir *= *\)\$(prefix)/etc!\1@sysconfdir@!' \
	-e 's!\(^sysconfdir *= *\)\$(prefix)/etc!\1@datadir@!' \
	-e 's!\(^initdir *= *\)\$(prefix)/etc!\1@sysconfdir@!' < $f > $f.new
    mv $f.new $f
done

# Fix locations:
for f in project/acinclude.m4 configure ; do
    sed -e 's/\(LOCATION_DIR.*\)"\$prefix"/\1""/g' \
	-e 's/\(USER_DIR.*\)\.edg/\1.voms/g' < $f > $f.new
    mv $f.new $f
done
chmod 755 configure

# Use pdflatex:
for f in src/api/ccapi/Makefile.am src/api/ccapi/Makefile.in ; do
    sed -e 's!^\(USE_PDFLATEX *= *\)NO!\1YES!' < $f > $f.new
    mv $f.new $f
done

# Remove empty line before shebang
sed -e '1d' < src/install/mysql2oracle.in > src/install/mysql2oracle.in.new
mv src/install/mysql2oracle.in.new src/install/mysql2oracle.in

%build
%configure --libexecdir=%{_datadir} --disable-java
make %{?_smp_mflags}
( cd doc/apidoc/api/VOMS_C_API/latex ; make )
( cd doc/apidoc/api/VOMS_CC_API/latex ; make )

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/grid-security/vomsdir

rm -f $RPM_BUILD_ROOT%{_bindir}/edg-voms*
rm -f $RPM_BUILD_ROOT%{_sbindir}/edg-voms*
rm -f $RPM_BUILD_ROOT%{_mandir}/man1/edg-voms*
rm -f $RPM_BUILD_ROOT%{_mandir}/man8/edg-voms*
rm -rf $RPM_BUILD_ROOT%{_mandir}/man3

rm -f $RPM_BUILD_ROOT%{_libdir}/*.a
rm -f $RPM_BUILD_ROOT%{_libdir}/*.la

mv $RPM_BUILD_ROOT%{_includedir}/glite/security/%{name} \
   $RPM_BUILD_ROOT%{_includedir}/%{name}
rm -rf $RPM_BUILD_ROOT%{_includedir}/glite

rm $RPM_BUILD_ROOT%{_includedir}/%{name}/voms_apic_nog.h
rm $RPM_BUILD_ROOT%{_mandir}/man1/testvoms.1*
rm $RPM_BUILD_ROOT%{_mandir}/man8/voms-install-replica.8*

mkdir -p VOMS_C_API/html
install -m 644 doc/apidoc/api/VOMS_C_API/html/* VOMS_C_API/html
install -m 644 doc/apidoc/api/VOMS_C_API/latex/refman.pdf VOMS_C_API

mkdir -p VOMS_CC_API/html
install -m 644 doc/apidoc/api/VOMS_CC_API/html/* VOMS_CC_API/html
install -m 644 doc/apidoc/api/VOMS_CC_API/latex/refman.pdf VOMS_CC_API

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%post server
if [ $1 = 1 ]; then
    /sbin/chkconfig --add %{name}
fi

%preun server
if [ $1 = 0 ]; then
    /sbin/service %{name} stop >/dev/null 2>&1 || :
    /sbin/chkconfig --del %{name}
fi

%postun server
if [ $1 -ge 1 ]; then
    /sbin/service %{name} condrestart >/dev/null 2>&1 || :
fi

%files
%defattr(-,root,root,-)
%{_libdir}/libvomsapi.so.*
%{_libdir}/libvomsapi_nog.so.*
%{_libdir}/libvomsc.so.*
%doc AUTHORS LICENSE

%files devel
%defattr(-,root,root,-)
%dir %{_includedir}/%{name}
%{_includedir}/%{name}/acstack.h
%{_includedir}/%{name}/newformat.h
%{_includedir}/%{name}/voms_api.h
%{_includedir}/%{name}/voms_apic.h
%{_includedir}/%{name}/voms_api_nog.h
%{_libdir}/libvomsapi.so
%{_libdir}/libvomsapi_nog.so
%{_libdir}/libvomsc.so
%{_datadir}/m4/%{name}.m4

%files doc
%defattr(-,root,root,-)
%doc VOMS_C_API
%doc VOMS_CC_API

%files clients
%defattr(-,root,root,-)
%doc %{_sysconfdir}/vomses.template
%dir %{_sysconfdir}/grid-security
%dir %{_sysconfdir}/grid-security/vomsdir
%{_bindir}/voms-proxy-destroy
%{_bindir}/voms-proxy-info
%{_bindir}/voms-proxy-init
%{_bindir}/voms-proxy-fake
%{_bindir}/voms-proxy-list
%{_mandir}/man1/voms-proxy-destroy.1*
%{_mandir}/man1/voms-proxy-info.1*
%{_mandir}/man1/voms-proxy-init.1*
%{_mandir}/man1/voms-proxy-fake.1*
%{_mandir}/man1/voms-proxy-list.1*

%files server
%defattr(-,root,root,-)
%{_sbindir}/%{name}
%{_sysconfdir}/init.d/%{name}
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/mysql2oracle
%{_datadir}/%{name}/upgrade1to2
%{_datadir}/%{name}/voms.data
%{_datadir}/%{name}/voms_install_db
%{_datadir}/%{name}/voms-ping
%{_datadir}/%{name}/voms_replica_master_setup.sh
%{_datadir}/%{name}/voms_replica_slave_setup.sh
%{_mandir}/man8/voms.8*

%changelog
* Tue Jun 30 2009 Anders Waananen <waananen@nbi.dk> - 1.9.2-2
- Add SuSE dependencies

* Thu Feb 12 2009 Mattias Ellert <mattias.ellert@fysast.uu.se> - 1.9.2-1
- Upstream 1.9.2 (CVS branch glite-security-voms_R_1_9_2)

* Fri Feb  6 2009 Mattias Ellert <mattias.ellert@fysast.uu.se> - 1.9.1-1
- Upstream 1.9.1 (CVS branch glite-security-voms_R_1_9_1)

* Tue Jan  6 2009 Mattias Ellert <mattias.ellert@fysast.uu.se> - 1.8.10-1
- Upstream 1.8.10 (CVS branch glite-security-voms_R_1_8_10)
- Rebuild against distribution Globus
- Add clear SSL error patch needed for openssl > 0.9.8b
- Add missing return value patch

* Sun Oct 26 2008 Mattias Ellert <mattias.ellert@fysast.uu.se> - 1.8.9-1ng
- Upstream 1.8.9 (CVS branch glite-security-voms_R_1_8_9)
- Rebuild against Globus 4.0.8-0.11

* Thu May 15 2008 Anders Waananen <waananen@nbi.dk> - 1.7.24-4ng
- Add missing include patch

* Sat Apr 26 2008 Anders Waananen <waananen@nbi.dk> - 1.7.24-3ng
- Rebuild against Globus 4.0.7-0.10

* Sun Nov 25 2007 Anders Waananen <waananen@nbi.dk> - 1.7.24-2ng
- Fix GPT_LOCATION and GLOBUS_LOCATION detection in spec file

* Mon Oct 29 2007 Anders Waananen <waananen@nbi.dk> - 1.7.24-1ng
- Upstream 1.7.24 (CVS branch glite-security-voms_R_1_7_24_1)

* Mon Oct 15 2007 Anders Waananen <waananen@nbi.dk> - 1.7.23-1ng
- Upstream 1.7.23 (CVS branch glite-security-voms_R_1_7_23_1)

* Wed Sep 12 2007 Anders Waananen <waananen@nbi.dk> - 1.7.22-3ng
- Move /etc/voms/vomses back to /etc/vomses
- Added more openssl portability patches with input
  from Aake Sandgren <ake.sandgren@hpc2n.umu.se>

* Wed Sep 12 2007 Anders Waananen <waananen@nbi.dk> - 1.7.22-2ng
- Added more openssl portability patches with input
  from Aake Sandgren <ake.sandgren@hpc2n.umu.se>

* Mon Sep 10 2007 Anders Waananen <waananen@nbi.dk> - 1.7.22-1ng
- Try to link against system crypto library when Globus library is not
  available
- Make /etc/grid-security/vomsdir part of the voms sub-package
- Drop RPM prefix /etc
- Move the vomses.template to /etc/voms
- Use dashes instead of underscore in voms-install-replica.1 man page
- Do not try to link against system crypt library. Voms now
  does this internally.
- Upstream 1.7.22 (CVS branch glite-security-voms_R_1_7_22_1)

* Mon Jul 16 2007 Anders Waananen <waananen@nbi.dk> - 1.7.20-5ng
- Drop voms-struct_change.patch - problem is with libxml2

* Sat Jul 14 2007 Anders Waananen <waananen@nbi.dk> - 1.7.20-4ng
- Add missing openssl-devel dependency in voms-devel

* Thu Jul 12 2007 Anders Waananen <waananen@nbi.dk> - 1.7.20-3ng
- Add patch:
  - voms-struct_change.patch
    - Change API slightly - but now works with libxml2

* Thu Jul  8 2007 Anders Waananen <waananen@nbi.dk> - 1.7.20-2ng
- Make conditinal dependency on expat-devel (OpenSuSE 10.20 has only expat)

* Thu Jul  5 2007 Anders Waananen <waananen@nbi.dk> - 1.7.20-1ng
- Upstream 1.7.20 (CVS branch glite-security-voms_R_1_7_20_1) 

* Thu Jul  5 2007 Anders Waananen <waananen@nbi.dk> - 1.7.19-2ng
- Added patches:
  - voms-openssl_portability.patch
    - Support for newer OpenSSL-0.9.8
  - voms-isoc90_portability.patch
    - Support for older compilers
- Added openssl-devel build dependency

* Fri Jun 22 2007 Anders Waananen <waananen@nbi.dk> - 1.7.19-1ng
- Upstream 1.7.19 (CVS branch glite-security-voms_R_1_7_19_P2) 
- Remove patches (use shell substitutions instead)
- Disable Java API build

* Fri Jun 22 2007 Anders Waananen <waananen@nbi.dk> - 1.6.20-3ng
- Added Globus dependencies to voms-devel

* Mon Jul 24 2006 Anders Waananen <waananen@nbi.dk> - 1.6.20-2ng
- Fix dependency typo: Requires -> BuildRequires

* Sat May  6 2006 Anders Waananen <waananen@nbi.dk> - 1.6.20-1ng
- Many changes since upstream changed quite a lot.
- Added README.NorduGrid with packaging information
- Patches:
  - voms_openssl-0.9.8.patch
    - Support for OpenSSL 0.9.8
  - voms_noglobusopenssl-1.6.20.patch
    - Use system openssl rather than the one from Globus
    - Patch reworked for voms 1.6.20
  - Dont use project based (gLite) include paths
- Pseudo patches (fixes made at runtime and not from static patch files)
  - Fix broken --libexecdir support for configure
    (some systems do not have libexecdir = <prefix>/libexec)
  - Drop all documents except man pages which are pre-generated
    (section 3 man pages are skipped as well)
  - Do not use edg- prefix
    (can be turned on/off through macro)
  - Install flavored libraries in addition to non-flavored
    (can be turned on/off through macro)
  - Put start-up script in /etc/init.d
  - Move configuration files from <prefix>/etc to /etc

* Mon Dec 19 2005 Anders Waananen <waananen@nbi.dk> - 1.6.9-2
- Add patch voms_doc.patch to disable html and ps documentation
  and add man-mages and pdf files to distribution (make dist)
- Use rpm switch: --define "_autotools_bootstrap 1" to rebuild
  documentation and create "make dist" target
- Add patch voms_nohardcodelibexecdir.patch which use the libexecdir
  from configure rather than the hardcoded prefix/libexec

* Sun Nov 27 2005 Anders Waananen <waananen@nbi.dk> - 1.6.9-1
- Add patch voms_ssl_include.patch to add external openssl includes.
  Would be better to query globus_openssl about this

* Tue Oct 18 2005 Anders Waananen <waananen@nbi.dk> - 1.6.7-1
- Modfiy voms_noglobusopenssl.patch to match upstream
- Add patch voms_nops.patch to disable postscript versions of
  reference manual

* Fri Jun 17 2005 Anders Waananen <waananen@nbi.dk> - 1.5.4-1
- Remove the following patches:
  - voms_namespace.patch - Fixed in upstream
  - voms_external_mysql++-1.4.1.patch - Obsolete since mysql++ is no
    longer needed
  - voms-no_libs.path - Fixed in upstream
- Add Globus dependencies

* Wed Jun  1 2005 Anders Waananen <waananen@nbi.dk> - 1.4.1-3
- Do not hardcode Globus flavor but try to guess
- Remove explicit globus rpm Requirement
- Use external openssl - not globus_openssl

* Mon May  2 2005 Anders Waananen <waananen@nbi.dk> - 1.4.1-2
- Remove automake cache
- Add explicit dependency on mysql++-devel

* Sat Apr 30 2005 Anders Waananen <waananen@nbi.dk> - 1.4.1-1
- New upstream
- autogen.sh -> autobuild.sh

* Mon Apr 18 2005 Anders Waananen <waananen@nbi.dk> - 1.3.2-1
- Initial build.
